﻿package  {
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.BlendMode;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	/**
	* ...
	* @author Carly Gooch
	*/
	public class Circles extends Sprite{
		
		private var _redCircle:Sprite;
		private var _blueCircle:Sprite;
		private var _greenCircle:Sprite;
		private var _background:Shape;
		private var _output:TextField;
		
		private const CIRCLERADIUS:Number=100;
		
		public function Circles(width:Number, height:Number) {
			_background = new Shape();
			_background.graphics.beginFill(0x000000, 1);
			_background.graphics.drawRect(0, 0, width, height);
			_background.graphics.endFill();
			
			_redCircle = new Sprite();
			_redCircle.graphics.beginFill(0xFF0000, 1);
			_redCircle.graphics.drawCircle(0, 0, CIRCLERADIUS);
			_redCircle.graphics.endFill();
			
			_greenCircle = new Sprite();
			_greenCircle.graphics.beginFill(0x00FF00, 1);
			_greenCircle.graphics.drawCircle(0, 0, CIRCLERADIUS);
			_greenCircle.graphics.endFill();
			
			_blueCircle = new Sprite();
			_blueCircle.graphics.beginFill(0x0000FF, 1);
			_blueCircle.graphics.drawCircle(0, 0, CIRCLERADIUS);
			_blueCircle.graphics.endFill();
			
			_redCircle.x = width / 2 - CIRCLERADIUS;
			_redCircle.y = height / 2 - CIRCLERADIUS;
			
			_greenCircle.x = width / 2;
			_greenCircle.y = height / 2 - CIRCLERADIUS;
			
			_blueCircle.x = width / 2 - CIRCLERADIUS/2;
			_blueCircle.y = height / 2;
			
			_redCircle.blendMode = BlendMode.SCREEN;
			_greenCircle.blendMode = BlendMode.SCREEN;
			_blueCircle.blendMode = BlendMode.SCREEN;
			
			
			_redCircle.addEventListener(MouseEvent.MOUSE_DOWN, startDragCircle);
			_redCircle.addEventListener(MouseEvent.MOUSE_UP, stopDragCircle);
			_greenCircle.addEventListener(MouseEvent.MOUSE_DOWN, startDragCircle);
			_greenCircle.addEventListener(MouseEvent.MOUSE_UP, stopDragCircle);
			_blueCircle.addEventListener(MouseEvent.MOUSE_DOWN, startDragCircle);
			_blueCircle.addEventListener(MouseEvent.MOUSE_UP, stopDragCircle);
			
	
			_output = new TextField();
			_output.autoSize = "left";
			_output.text = "Click anywhere to get a colour value...";
			
			_output.x = 10;
			_output.y = 10;
			_output.textColor = 0xFFFFFF;
			
			
			this.addEventListener(MouseEvent.CLICK, outputColour);
			
			this.addChild(_background);
			this.addChild(_redCircle);
			this.addChild(_blueCircle);
			this.addChild(_greenCircle);
			
			this.addChild(_output);
		}
		
		private function outputColour(e:MouseEvent):void {
			var bitmapData:BitmapData = new BitmapData(this.width, this.height, false, 0x000000);
			bitmapData.draw(this);
			
			var outputString:String = bitmapData.getPixel(this.mouseX, this.mouseY).toString(16);
			var leadingZeros:String = "";
			for (var i:Number = 1; i <= 6 - outputString.length; i++) {
				leadingZeros += "0";
			}
			_output.text = leadingZeros + outputString;
			
		
			
		}
		public function changeAlpha(circleID:String, alpha:Number):void {
			switch(circleID) {
				case "red": _redCircle.alpha = alpha; break;
				case "green": _greenCircle.alpha = alpha; break;
				case "blue": _blueCircle.alpha = alpha; break;
			}
		}
		
		private function startDragCircle(e:MouseEvent):void {
			Sprite(e.target).startDrag(false);
		}
		private function stopDragCircle(e:MouseEvent):void {
			Sprite(e.target).stopDrag();
		}
		
	}
	
}