﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.display.GradientType;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	public class MainBitmap extends MovieClip
	{
		public var isDrawing:Boolean;
		
		private const WIDTH:Number = 800;
		private const HEIGHT:Number = 600;
		
		private var background:Sprite;
		private var stars1:Bitmap;
		private var stars2:Bitmap;
		
		private var starBitmapData:BitmapData;
		private var starBitmapData2:BitmapData;
		
		private var starsDrawing:Sprite;
		
		private var moveDirection:Number;
		
		private var layers:Array;
		
		private var currentLayer:Number;
		
		public function MainBitmap():void
		{
			//draw background...
			var fillType:String = GradientType.LINEAR;
			var colors:Array = [0x034d72, 0x032637];
			var alphas:Array = [1, 1];
			var ratios:Array = [0x00, 0xFF];
			var matr:Matrix = new Matrix();
			//matrix is in radians..
			matr.createGradientBox(800, 600, Math.PI / 2, 0, 0);
			background = new Sprite();
			background.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr);
			background.graphics.drawRect(0, 0, WIDTH, HEIGHT);
			
			layers = new Array();
			this.addChild(background);
			
			
			
			
			starBitmapData = new BitmapData(WIDTH, HEIGHT,true,0x00000000);
			starBitmapData2 = new BitmapData(WIDTH, HEIGHT,true,0x00000000);
			stars1 = new Bitmap(starBitmapData);
			stars2 = new Bitmap(starBitmapData2);
			layers.push(stars1);
			layers.push(stars2);
			
			this.addChild(stars1);
			this.addChild(stars2);			
			
			starsDrawing = new Sprite();
		
			isDrawing = false;

			
			this.addEventListener(MouseEvent.MOUSE_DOWN, startDraw);
			this.addEventListener(MouseEvent.MOUSE_UP, stopDraw);
			this.addEventListener(Event.ENTER_FRAME, onDraw);
			
			moveDirection = 1;
			
			currentLayer = 0;
		}
		
		private function onDraw(e:Event):void 
		{
			if (isDrawing)
			{
				drawStar(this.mouseX,this.mouseY,0xFFFFFF * Math.random(), 5, Math.random() * 25, Math.random() * 25 + 25, Math.random() * 180);
			}
			
			var starBitmap:Bitmap = Bitmap(layers[0]);
			starBitmap.y += moveDirection;
			
			for (var i:Number = 0; i < layers.length; i++)
			{
				layers[i].y += moveDirection * (i+1);
				
			}
			
			starBitmap.y += moveDirection;
			
			if (starBitmap.y >= 100)
			{
				starBitmap.y = 100;
				moveDirection = -1;
			}
			if (starBitmap.y <= 0)
			{
				starBitmap.y = 0;
				moveDirection = 1;
			}
			
			
			//starBitmap.alpha -= .1;
			//starBitmap.alpha = 1;
			
			//starBitmapData.applyFilter(starBitmapData, new Rectangle(0, 0, WIDTH, HEIGHT),new Point(0,0),new BlurFilter(1.1, 1.1, 1));
		
		}
		
		private function stopDraw(e:MouseEvent):void 
		{
			isDrawing = false;
		}
		
		private function startDraw(e:MouseEvent):void 
		{
			isDrawing = true;
			currentLayer++;
			if (currentLayer >= layers.length)
			{
				currentLayer = 0; 
			}
		}
		
		public function drawStar(x:Number,y:Number,colour:Number = 0xFFFF00,numTips:int = 5, innerRadius:Number = 25, outerRadius:Number = 50,angle:Number = 0 ):void
		{
			
			starsDrawing.graphics.clear();
			starsDrawing.graphics.lineStyle(1, colour, 1);
		
			if (numTips > 2)
			{
				var centerX:Number = outerRadius;
				var centerY:Number = outerRadius;
				var step:Number, halfStep:Number, startAngle:Number, dx:Number, dy:Number;
				
				step = (Math.PI * 2) / numTips;
				halfStep = step / 2;
				
				//convert angle to radians
				startAngle = (angle / 180) * Math.PI
				
				dx = centerX + (Math.cos(startAngle) * outerRadius)+x;
				dy = centerY - (Math.sin(startAngle) * outerRadius)+y;
				
				starsDrawing.graphics.moveTo(dx, dy);
				
				for (var i:int = 1; i <= numTips; i++)
				{
					dx = centerX + Math.cos(startAngle + (step * i) - halfStep) * innerRadius+x;
					dy = centerY - Math.sin(startAngle + (step * i) - halfStep) * innerRadius+y;
					

					starsDrawing.graphics.lineTo(dx, dy);
					
					dx = centerX + Math.cos(startAngle + (step * i)) * outerRadius+x;
					dy = centerY - Math.sin(startAngle + (step * i)) * outerRadius+y;

					starsDrawing.graphics.lineTo(dx, dy);
				}
				
				var bData:BitmapData = Bitmap(layers[currentLayer]).bitmapData;
				//var bData:BitmapData = starBitmapData;
				bData.draw(starsDrawing);	
			}	
		}
	}
}