﻿package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.filters.BlurFilter;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	/**
	* ...
	* @author Carly Gooch
	* 
	* ideas and colour from http://www.photoshopsupport.com/tutorials/jennifer/night-vision.html
	*/
	public class NightVision extends Sprite
	{
		
		[Embed(source = 'img/koala.jpg')]
		private var KoalaImage:Class;
		
		private var image:Bitmap;
		
		private const COLOR1:Number=0x25BF21;
		private const COLOR2:Number=0xA8D9A7;
		
		public function NightVision() 
		{
			image = new KoalaImage();
			
			addChild(image);
			
			applyNightVision();
		}
		
		private function applyNightVision():void
		{
			//desaturate colours 1/3 of the colour
			var red:Number = 0.1;
			var green:Number = 0.5;
			var blue:Number = 0.1;
			
			var matrix:Array = new Array();
            matrix = matrix.concat([red, red, red, 0, 0]); // red
            matrix = matrix.concat([green, green, green, 0, 0]); // green
            matrix = matrix.concat([blue, blue, blue, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
			
			var blutFilter:BlurFilter = new BlurFilter(2, 2, 1);
			filters.push(blutFilter);
			
			var noiseBitmapData:BitmapData = new BitmapData(image.width, image.height);
			noiseBitmapData.noise(1,0,255,7,true);
			image.filters = filters;
			image.bitmapData.merge(noiseBitmapData, new Rectangle(0, 0, image.width, image.height), new Point(0, 0), 25, 25, 25, .2);
			
			
			/*var matrix:Array = new Array();
            matrix = matrix.concat([currentRed, 0, 0, 0, 0]); // red
            matrix = matrix.concat([0, currentGreen, 0, 0, 0]); // green
            matrix = matrix.concat([0, 0, currentBlue, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha*/
		}
		
		
		
	}
	
}