﻿package  
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shader;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Video;
	import flash.media.Camera;
	import flash.filters.BlurFilter;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.net.URLRequest;
	import flash.net.URLLoaderDataFormat;
	
	/**
	* ...
	* @author Carly Gooch
	*/
	public class MaskVideo extends MovieClip
	{
		
		private var wordField:TextField;
		private var wordSprite:Sprite;
		
		private var wordBitmap:Bitmap;
		
		private var WIDTH:Number = 800;
		private var HEIGHT:Number = 600;
		
		private var videoBitmap:Bitmap;
		private var videoBitmapData:BitmapData;
		private var video:Video;
		
		private var shader:Shader;
		private var shaderLoader:URLLoader;
		
		private var outputSprite:Sprite;
		
		private var xDirection:Number;
		private var yDirection:Number;
		private var speed:Number;
		
		public function MaskVideo() 
		{
			outputSprite = new Sprite();
			
			
			xDirection = 1;
			yDirection = 1;
			speed = 5;
			
			drawWords();
			drawVideo();
			drawShader();
			
			this.addChild(outputSprite);
		}
		
		private function drawShader():void
		{
			//create the shader
			shader = new Shader();

			//load the shader
			shaderLoader = new URLLoader();
			shaderLoader.dataFormat = URLLoaderDataFormat.BINARY;
			shaderLoader.addEventListener(Event.COMPLETE, shaderLoaded);
			//your filter file has to be relative to the compiled swf
			shaderLoader.load(new URLRequest("mask.pbj"));
		}
		private function shaderLoaded(e:Event):void 
		{
			try {
				//set up the shader
				shader.byteCode = shaderLoader.data; // error if invalid
				this.addEventListener(Event.ENTER_FRAME, animate);			
			}catch (error:Error)
			{
					trace("error" + error);
			}
		}
		
		private function animate(e:Event):void 
		{
			
			wordField.rotationX += 5;
			
			//wordField.rotationX++;
			videoBitmapData.draw(video);
			
			if (wordField.x + wordField.width > WIDTH)
			{
				xDirection = -1;
			}else if (wordField.x < 0)
			{
				xDirection = 1;
			}
			if (wordField.y + wordField.height > HEIGHT)
			{
				yDirection = -1;
			}else if (wordField.y < 0)
			{
				yDirection = 1;
			}
			wordField.x += xDirection*speed;
			wordField.y += yDirection*speed;
			//wordField.rotationX++;
			
			//set the source input to the bitmap data of the image 
				shader.data.src.input = videoBitmapData; // image input
				wordBitmap.bitmapData = new BitmapData(WIDTH, HEIGHT, false, 0x000000);
				wordBitmap.bitmapData.draw(wordSprite);
				wordBitmap.bitmapData.applyFilter(wordBitmap.bitmapData, new Rectangle(0, 0, WIDTH, HEIGHT),new Point(0,0),new BlurFilter());
				
				
				
				//this.addChild(wordBitmap);
				shader.data.mask.input = wordBitmap.bitmapData; // image input
				
				
				//draw the shader onto the screen in a rectangle
				outputSprite.graphics.clear();
				outputSprite.graphics.beginShaderFill(shader);
				outputSprite.graphics.drawRect(0, 0, WIDTH, HEIGHT);
				
				
		}
		
		private function drawVideo():void
		{
			video = new Video(WIDTH,HEIGHT);
			video.attachCamera(Camera.getCamera());
			
			videoBitmapData = new BitmapData(video.width, video.height);
			videoBitmap = new Bitmap(videoBitmapData);
			
		}
		
		public function drawWords():void
		{
			wordSprite = new Sprite();
			wordField = new TextField();
			var wordFormat:TextFormat = wordField.getTextFormat();
			wordFormat.size = 100;
			wordFormat.font = "Verdana";
			wordFormat.bold = true;
			wordField.antiAliasType = flash.text.AntiAliasType.NORMAL;
			
			wordField.autoSize = "left";
			wordField.defaultTextFormat = wordFormat;
			wordField.selectable = false;
			wordField.textColor = 0xFF00FF;
			wordField.text = "Hello David";
			wordField.x = 100;
			wordField.y = 100;
			wordSprite.addChild(wordField);
			
			addChild(wordSprite);
			
			wordSprite.graphics.beginFill(0x000000, 1);
			wordSprite.graphics.drawRect(0, 0, WIDTH, HEIGHT);
			
			var textFilter:BlurFilter = new BlurFilter(10,10,1);
			var filtersArr:Array = new Array();
			filtersArr.push(textFilter);
			wordField.filters = filtersArr;
			
			
			
			wordBitmap = new Bitmap(new BitmapData(WIDTH, HEIGHT, false, 0x000000));
			//this.addChild(wordBitmap);
		}
		
	}
	
}