﻿/*
 *  PAPER    ON   ERVIS  NPAPER ISION  PE  IS ON  PERVI IO  APER  SI  PA
 *  AP  VI  ONPA  RV  IO PA     SI  PA ER  SI NP PE     ON AP  VI ION AP
 *  PERVI  ON  PE VISIO  APER   IONPA  RV  IO PA  RVIS  NP PE  IS ONPAPE
 *  ER     NPAPER IS     PE     ON  PE  ISIO  AP     IO PA ER  SI NP PER
 *  RV     PA  RV SI     ERVISI NP  ER   IO   PE VISIO  AP  VISI  PA  RV3D
 *  ______________________________________________________________________
 *  papervision3d.org + blog.papervision3d.org + osflash.org/papervision3d
 */

// _______________________________________________________________________ Cube

package
{
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.MovieClip;
import flash.display.Sprite;
import flash.events.Event;
import flash.media.Camera;
import flash.media.Video;
import org.papervision3d.core.Number3D;
import org.papervision3d.core.proto.MaterialObject3D;

// Import Papervision3D
import org.papervision3d.scenes.Scene3D;
import org.papervision3d.cameras.Camera3D;
import org.papervision3d.objects.Cube;
import org.papervision3d.materials.MaterialsList;

import org.papervision3d.materials.MovieAssetMaterial;
import org.papervision3d.materials.MovieMaterial;

public class Main extends Sprite
{
	//---------------------GRAPHICS-----------------------------------------
	[Embed(source='img/eagle.jpg')]
	private var EagleImage:Class;
	private var faceImage:Bitmap;
	
	//-----------------------WEBCAM------------------------------------
	private var videoBitmap:Bitmap;
	private var videoBitmapData:BitmapData;
	private var video:Video;
	
	// ___________________________________________________________________ Static

	static public var SCREEN_WIDTH  :int = 800;
	static public var SCREEN_HEIGHT :int = 600;

	// ___________________________________________________________________ 3D vars

	private var container :Sprite;
	private var scene     :Scene3D;
	private var camera    :Camera3D;
	private var cube      :Cube;

	// ___________________________________________________________________ main

	public function Main()
	{
		init3D();

		createCube();

		this.addEventListener( Event.ENTER_FRAME, loop );
	}
	
	


	// ___________________________________________________________________ Init3D

	private function init3D():void
	{
		// Create container sprite and center it in the stage
		container = new Sprite();
		addChild( container );
		container.x = SCREEN_WIDTH  /2;
		container.y = SCREEN_HEIGHT /2;

		//initialise video
		initVideo();
		
		// Create scene
		scene = new Scene3D( container );

		// Create camera
		camera = new Camera3D();
		camera.translate( -400, new Number3D(0, 0, 1));
		
	}
	
	private function initVideo():void
	{
		video = new Video();
		video.attachCamera(Camera.getCamera());
	}


	// ___________________________________________________________________ Create Cube

	private function createCube():void
	{
		// Attributes
		var size :Number = 1000;
		var quality :Number = 6;
	
		
		faceImage = new EagleImage();
		
		videoBitmapData = new BitmapData(320, 240, false,0xFF000000);
		
		videoBitmap = new Bitmap(videoBitmapData);
		
		
		videoBitmap.y = 300;
		
		
		// Materials
		var materials:MaterialsList = new MaterialsList(
		{
			//all:
			front:  new MovieMaterial( videoBitmap,false,true ),
			back:   new MovieMaterial( videoBitmap,false,true ),
			right:  new MovieMaterial( videoBitmap,false,true ),
			left:   new MovieMaterial( videoBitmap,false,true ),
			top:    new MovieMaterial( videoBitmap,false,true ),
			bottom: new MovieMaterial( videoBitmap,false,true )
		} );
		
		//var material:MaterialObject3D = materials.getMaterialByName("bottom");
		
		//faceImage2.bitmapData.noise(5);
		//var faceImage2bdata:BitmapData = material.bitmap;
		//faceImage2bdata.noise(5);

		// Cube face settings
		// You can add or sustract faces to your selection. For examples: Cube.FRONT+Cube.BACK or Cube.ALL-Cube.Top.

		// On single sided materials, all faces will be visible from the inside.
		var insideFaces  :int = Cube.NONE;

		// Front and back cube faces will not be created.
		var excludeFaces :int = Cube.NONE;

		// Create the cube.
		cube = new Cube( materials, size, size, size, quality, quality, quality, insideFaces, excludeFaces );

		scene.addChild( cube, "Cube" );
	}


	// ___________________________________________________________________ Loop

	private function loop(event:Event):void
	{
		update3D();
	}


	private function update3D():void
	{
		videoBitmapData.draw(video);
		
		cube.rotationY = container.mouseX / 2;
		cube.rotationX = container.mouseY / 2;

		
		
		// Render
		scene.renderCamera( this.camera );
		
	}
}
}